package com.ejie.ab63.model;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * Ab6300s00  
 * 
 *  
 */

public class Recurso implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private String idRecurso;
	private String tipoRecurso;
	private String descNombre;
	private Date fechaBaja;
	private String numRegistro;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltmodificacion;
	private String usuarioUltmodificacion;
	private List<Establecimiento> ab6301s00s = new ArrayList<Establecimiento>();
	private String signatura;
	private List<Aseo> aseos;

	private String appOrigen;
	private String accion;
	private String signaturaAnterior;
	private Long codigo;
	private String fechaHora;
	private String nombre;
	private Date fechaInicioCierreTemporal;
	private Date fechaFinCierreTemporal;

	/**
	 * Method 'Ab6300s00'.
	 */
	public Recurso() {
	}

	/**
	 * Method 'Ab6300s00'.
	 * 
	 * @param idRecurso
	 *            String
	 */
	public Recurso(String idRecurso) {
		this.idRecurso = idRecurso;
	}

	/**
	 * Method 'Ab6300s00'.
	 * 
	 * @param idRecurso
	 *            String
	 * @param tipoRecurso
	 *            String
	 * @param descNombre
	 *            String
	 * @param fechaBaja
	 *            Date
	 * @param numRegistro
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 */
	public Recurso(String idRecurso, String tipoRecurso, String descNombre, Date fechaBaja, String numRegistro,
			Date fechaRegistro, String usuarioRegistro, Date fechaUltmodificacion, String usuarioUltmodificacion) {
		this.idRecurso = idRecurso;
		this.tipoRecurso = tipoRecurso;
		this.descNombre = descNombre;
		this.fechaBaja = fechaBaja;
		this.numRegistro = numRegistro;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Method 'Ab6300s00'.
	 * 
	 * @param idRecurso
	 *            String
	 * @param tipoRecurso
	 *            String
	 * @param descNombre
	 *            String
	 * @param fechaBaja
	 *            Date
	 * @param numRegistro
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 * @param ab6301s00s
	 *            List<Ab6301s00>
	 */
	public Recurso(String idRecurso, String tipoRecurso, String descNombre, Date fechaBaja, String numRegistro,
			Date fechaRegistro, String usuarioRegistro, Date fechaUltmodificacion, String usuarioUltmodificacion,
			List<Establecimiento> ab6301s00s) {

		this.idRecurso = idRecurso;
		this.tipoRecurso = tipoRecurso;
		this.descNombre = descNombre;
		this.fechaBaja = fechaBaja;
		this.numRegistro = numRegistro;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
		this.ab6301s00s = ab6301s00s;
	}

	/**
	 * Method 'getIdRecurso'.
	 *
	 * @return String
	 */

	public String getIdRecurso() {
		return this.idRecurso;
	}

	/**
	 * Method 'setIdRecurso'.
	 *
	 * @param idRecurso
	 *            String
	 * @return
	 */

	public void setIdRecurso(String idRecurso) {
		this.idRecurso = idRecurso;
	}

	/**
	 * Method 'getTipoRecurso'.
	 *
	 * @return String
	 */

	public String getTipoRecurso() {
		return this.tipoRecurso;
	}

	/**
	 * Method 'setTipoRecurso'.
	 *
	 * @param tipoRecurso
	 *            String
	 * @return
	 */

	public void setTipoRecurso(String tipoRecurso) {
		this.tipoRecurso = tipoRecurso;
	}

	/**
	 * Method 'getDescNombre'.
	 *
	 * @return String
	 */

	public String getDescNombre() {
		return this.descNombre;
	}

	/**
	 * Method 'setDescNombre'.
	 *
	 * @param descNombre
	 *            String
	 * @return
	 */

	public void setDescNombre(String descNombre) {
		this.descNombre = descNombre;
	}

	/**
	 * Method 'getFechaBaja'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaBaja() {
		return this.fechaBaja;
	}

	/**
	 * Method 'setFechaBaja'.
	 *
	 * @param fechaBaja
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaBaja(Date fechaBaja) {
		this.fechaBaja = fechaBaja;
	}

	/**
	 * Method 'getNumRegistro'.
	 *
	 * @return String
	 */

	public String getNumRegistro() {
		return this.numRegistro;
	}

	/**
	 * Method 'setNumRegistro'.
	 *
	 * @param numRegistro
	 *            String
	 * @return
	 */

	public void setNumRegistro(String numRegistro) {
		this.numRegistro = numRegistro;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getFechaUltmodificacion'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltmodificacion() {
		return this.fechaUltmodificacion;
	}

	/**
	 * Method 'setFechaUltmodificacion'.
	 *
	 * @param fechaUltmodificacion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltmodificacion(Date fechaUltmodificacion) {
		this.fechaUltmodificacion = fechaUltmodificacion;
	}

	/**
	 * Method 'getUsuarioUltmodificacion'.
	 *
	 * @return String
	 */

	public String getUsuarioUltmodificacion() {
		return this.usuarioUltmodificacion;
	}

	/**
	 * Method 'setUsuarioUltmodificacion'.
	 *
	 * @param usuarioUltmodificacion
	 *            String
	 * @return
	 */

	public void setUsuarioUltmodificacion(String usuarioUltmodificacion) {
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Method 'getAb6301s00s'.
	 *
	 * @return List
	 */
	@JsonIgnore
	public List<Establecimiento> getAb6301s00s() {
		return this.ab6301s00s;
	}

	/**
	 * Method 'setAb6301s00s'.
	 *
	 * @param ab6301s00s
	 *            List
	 * @return
	 */
	public void setAb6301s00s(List<Establecimiento> ab6301s00s) {
		this.ab6301s00s = ab6301s00s;
	}

	/**
	 * @return the signatura
	 */
	public String getSignatura() {
		return signatura;
	}

	/**
	 * @param signatura
	 *            the signatura to set
	 */
	public void setSignatura(String signatura) {
		this.signatura = signatura;
	}

	/**
	 * @return the aseos
	 */
	public List<Aseo> getAseos() {
		return aseos;
	}

	/**
	 * @param aseos
	 *            the aseos to set
	 */
	public void setAseos(List<Aseo> aseos) {
		this.aseos = aseos;
	}

	/**
	 * @return the appOrigen
	 */
	public String getAppOrigen() {
		return appOrigen;
	}

	/**
	 * @param appOrigen
	 *            the appOrigen to set
	 */
	public void setAppOrigen(String appOrigen) {
		this.appOrigen = appOrigen;
	}

	/**
	 * @return the accion
	 */
	public String getAccion() {
		return accion;
	}

	/**
	 * @param accion
	 *            the accion to set
	 */
	public void setAccion(String accion) {
		this.accion = accion;
	}

	/**
	 * @return the signaturaAnterior
	 */
	public String getSignaturaAnterior() {
		return signaturaAnterior;
	}

	/**
	 * @param signaturaAnterior
	 *            the signaturaAnterior to set
	 */
	public void setSignaturaAnterior(String signaturaAnterior) {
		this.signaturaAnterior = signaturaAnterior;
	}

	/**
	 * @return the codigo
	 */
	public Long getCodigo() {
		return codigo;
	}

	/**
	 * @param codigo
	 *            the codigo to set
	 */
	public void setCodigo(Long codigo) {
		this.codigo = codigo;
	}

	/**
	 * @return the fechaHora
	 */
	public String getFechaHora() {
		return fechaHora;
	}

	/**
	 * @param fechaHora
	 *            the fechaHora to set
	 */
	public void setFechaHora(String fechaHora) {
		this.fechaHora = fechaHora;
	}

	/**
	 * @return the nombre
	 */
	public String getNombre() {
		return nombre;
	}

	/**
	 * @param nombre
	 *            the nombre to set
	 */
	public void setNombre(String nombre) {
		this.nombre = nombre;
	}

	/**
	 * @return the fechaInicioCierreTemporal
	 */
	public Date getFechaInicioCierreTemporal() {
		return fechaInicioCierreTemporal;
	}

	/**
	 * @param fechaInicioCierreTemporal
	 *            the fechaInicioCierreTemporal to set
	 */
	public void setFechaInicioCierreTemporal(Date fechaInicioCierreTemporal) {
		this.fechaInicioCierreTemporal = fechaInicioCierreTemporal;
	}

	/**
	 * @return the fechaFinCierreTemporal
	 */
	public Date getFechaFinCierreTemporal() {
		return fechaFinCierreTemporal;
	}

	/**
	 * @param fechaFinCierreTemporal
	 *            the fechaFinCierreTemporal to set
	 */
	public void setFechaFinCierreTemporal(Date fechaFinCierreTemporal) {
		this.fechaFinCierreTemporal = fechaFinCierreTemporal;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idRecurso: ").append(this.idRecurso).append(" ]");
		result.append(", [ tipoRecurso: ").append(this.tipoRecurso).append(" ]");
		result.append(", [ descNombre: ").append(this.descNombre).append(" ]");
		result.append(", [ fechaBaja: ").append(this.fechaBaja).append(" ]");
		result.append(", [ numRegistro: ").append(this.numRegistro).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append(", [ fechaUltmodificacion: ").append(this.fechaUltmodificacion).append(" ]");
		result.append(", [ usuarioUltmodificacion: ").append(this.usuarioUltmodificacion).append(" ]");
		result.append("}");
		return result.toString();
	}

}